#include "base.as"


int deletedID = 0;



//truck properties
string tName = "";
vector3 TruckPosition;
vector3 newPos;
float truckHeight;
quaternion qrot;

//cans
string canFile = "vh-trash-can.load";
string trashTruckFile = "vh-trash.truck";
int trashTruckID;
int canCount;
//array<Can> TrashCans;
array<int> TrashId;
array<BeamClass@> TruckInstances;


void main()
{	
	TruckInstances = game.getAllTrucks();
	game.registerForEvent(SE_GENERIC_DELETED_TRUCK);
	game.registerForEvent(SE_GENERIC_NEW_TRUCK);
	
	
	for (uint i = 0; i < TruckInstances.length(); i++)
	{
		if (TruckInstances[i].getTruckFileName() == trashTruckFile)
		{
		  trashTruckID = TruckInstances[i].getInstanceId();
		}
	}
}

void eventCallbackEx(scriptEvents event, int arg1, int arg2ex, int arg3ex, int arg4ex, string arg5ex, string arg6ex, string arg7ex, string arg8ex)
{            
		// Arguments of `eventCallbackEx()`: #1 type, #2 Actor Instance ID (use `game.getTruckByNum()`), #3 unused, #4 unused, #5 object instance name, #6 eventbox name #7 unused #8 unused.
		
		int deletedIndex;
		int temp;
		// newly spawned actor
        if (event == SE_GENERIC_NEW_TRUCK)
        {
			if (game.getTruckByNum(arg1).getHandle().getTruckFileName() == trashTruckFile)
			 {
					temp = arg1;
					trashTruckID = temp;
	
			} 
			if (game.getTruckByNum(arg1).getHandle().getTruckFileName() == canFile)
			 {
				if (arg1 != 0)
				{
					TrashId.insertLast(arg1);
				}
			} 
		}
		//deleted actors
		if (event == SE_GENERIC_DELETED_TRUCK)
        {	
			if (TrashId != null)
			{
				if (TrashId.length() > 0)
				{
					deletedID = arg1;
					deletedIndex = TrashId.find(deletedID);

					if (TrashId.find(deletedID) != -1)
					{
						if (TrashId.length() > 0)
						{
							TrashId.removeAt(deletedIndex);
						}
					}
				}	
			}
		  
		} 
}

void EditorPanel()
{

	if (game.getCurrentTruck().getHandle().getTruckFileName() == trashTruckFile)
	{
		TruckPosition = game.getTruckByNum(trashTruckID).getHandle().getNodePosition(208);
		
			ImGui::Text("Add Cans "); 
		if (ImGui::Button("Behind"))
		{
		
			newPos = (((vector3(TruckPosition.x, 0, TruckPosition.z)) + vector3(0, (truckHeight-0.1),0) - (qrot*vector3(-0.5,0,-0.5))));

			game.pushMessage(MSG_SIM_SPAWN_ACTOR_REQUESTED, 

			{ 
			{"filename", canFile},
			{"enter", false},
			{"position", newPos},
			{"rotation", qrot}
			}
			);	
		}
	}
	if (ImGui::CollapsingHeader("Cans"))
	{
		for (uint i = 0; i < TrashId.length(); i++)		
		{	
			ImGui::BulletText(""+game.getTruckByNum(TrashId[i]).getHandle().getTruckName() +" ");
			ImGui::SameLine();
			
			if (ImGui::SmallButton("ID: " +TrashId[i]+ " : Remove"))
			{
				game.pushMessage(MSG_SIM_DELETE_ACTOR_REQUESTED, {{"instance_id", TrashId[i]}});
			}
		}
	}
}
/*
---------------------------------------------------------------------------
Script update function - invoked once every rendered frame,
with elapsed time (delta time, in seconds) as parameter.
*/
void frameStep(float dt)
{

    BeamClass@ actor = game.getCurrentTruck();

	if  (actor != null)
	{
		ImGui::Begin("Garbage Collection Demo", /*open:*/true, ImGuiWindowFlags_AlwaysAutoResize);

		tName = actor.getTruckName();
		truckHeight = game.getTruckByNum(trashTruckID).getHandle().getNodePosition(157).y;
		qrot = quaternion((radian(3.14/-2) + game.getTruckByNum(trashTruckID).getHandle().getOrientation().getYaw()), vector3(0, 1 ,0)); 

		ImGui::Text("Garbage Truck Test");
		ImGui::Text("Current Vehicle: "+tName);
			  
		if (findNearestCanID() != 0)
		{
				ImGui::Text("Closest Can: " +findNearestCanID() +"  ");
		}
		if (ImGui::Button("Go to Can"))
		{
			if (findNearestCanID() != -1)
			{
				game.pushMessage(MSG_SIM_SEAT_PLAYER_REQUESTED, {{"instance_id", findNearestCanID()}});
			}
			else
			{
				ImGui::Button("Go to Can");
			}
		}
		
		ImGui::SameLine();
		
		if (ImGui::Button("Go to truck"))
		{
			if (trashTruckID != -1)
			{
				game.pushMessage(MSG_SIM_SEAT_PLAYER_REQUESTED, {{"instance_id", trashTruckID}});
			}
		}
			  EditorPanel();
			
			//Can adding UI  

		ImGui::End();
	}

}
float Distance(vector3 obj1, vector3 obj2)
{
	float Dis;
	float x1 = obj1.x;
	float x2 = obj2.x;
	float y1 = obj1.y;
	float y2 = obj2.y;
	float z1 = obj1.z;
	float z2 = obj2.z;
	
	return Dis = (pow((sqrt(x2-x1)) + (sqrt(y2-y1)) + (sqrt(z2-z1)), 0.5)* 10);
	
	ImGui::Text("Distance: " +Dis);
}
int findNearestCanID()
{
	float nearestID;
	
	if (TrashId.length() > 0)
	{
		for (uint i = 0; i < TrashId.length(); i++)
		{	
			float distanceFromTruck = Distance(game.getTruckByNum(TrashId[i]).getHandle().getPosition(), game.getTruckByNum(trashTruckID).getHandle().getNodePosition(201) + vector3(2.2, 2.2, 2.2));
			
			
			if ((distanceFromTruck > 20) and (distanceFromTruck < 22))
			{
				
				nearestID = TrashId[i];
				//game.log("Dis " +distanceFromTruck);
			}
		}
	}
		
	return nearestID;
}


